<template>
  <div class="RangePicker">
    <span class="RangePicker__Label" v-if="label">{{ label }}</span>

    <!--suppress HtmlUnknownTag -->
    <v-date-picker
      class="RangePicker__Comp"
      v-model="range"
      @update:modelValue="update"
      mode="dateTime"
      :locale="locale"
      :masks="masks"
      :isDark="isDark"
      :input-debounce="500"
      :minute-increment="5"
      is24hr
      is-range
      update-on-input
    >
      <template
        v-slot="{
          inputValue,
          inputEvents,
          showPopover,
          hidePopover,
          isDragging,
        }"
      >
        <div
          class="RangePicker__Inputs"
          @focusin="showPopover"
          @focusout="hidePopover"
        >
          <!--suppress HtmlFormInputWithoutLabel -->
          <input
            class="RangePicker__InputStart RangePicker__Input"
            :class="{ 'RangePicker__Input--dragging': isDragging }"
            :value="inputValue.start"
            @input="inputEvents.start.input"
            @change="inputEvents.start.change"
            @keyup="inputEvents.start.keyup"
            :title="t('entry.date.start')"
          />

          <Icon :icon="Icons.arrowRight" />

          <!--suppress HtmlFormInputWithoutLabel -->
          <input
            class="RangePicker__InputStop RangePicker__Input"
            :class="{ 'RangePicker__Input--dragging': isDragging }"
            :value="inputValue.end"
            @input="inputEvents.end.input"
            @change="inputEvents.end.change"
            @keyup="inputEvents.end.keyup"
            :title="t('entry.date.stop')"
          />
        </div>
      </template>
    </v-date-picker>
  </div>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  getCurrentInstance,
  inject,
  PropType,
} from 'vue'
import { Range } from '@/types'
import moment from 'moment'
import { Icon } from '@/components'
import { Icons } from '@/Icons'
import { theme } from '@/states'

interface DTPrange {
  start?: Date
  end?: Date
}

export default defineComponent({
  name: 'RangePicker',
  emits: ['update:modelValue'],
  components: { Icon },
  props: {
    label: String,
    placeholder: String,
    locale: String,
    modelValue: Object as PropType<Range>,
  },

  setup() {
    return {
      Icons,
      update: console.log,
      isDark: computed(() => theme.value.includes('Dark')),
      masks: {
        inputDateTime24hr:
          moment.localeData().longDateFormat('L') + ' HH:mm:ss',
      },
      t: inject('t', (str: unknown) => str),
    }
  },

  computed: {
    /**
     * Returns unique identifier of the current instance
     */
    uuid(): number {
      const cid = getCurrentInstance()
      if (cid) return cid.uid
      return -1
    },

    /**
     * A range for the picker
     */
    range: {
      get() {
        const range: DTPrange = {
          start: new Date(),
          end: new Date(),
        }
        if (this.modelValue) {
          range.start = this.modelValue.start
          range.end = this.modelValue.stop
        }
        return range
      },

      set(range: DTPrange) {
        const obj = Object.assign({}, this.modelValue, {
          start: range.start,
          stop: range.end,
        })
        this.$emit('update:modelValue', obj)
      },
    },
  },
})
</script>

<style lang="scss">
@use '../../style/variables' as v;

.RangePicker {
  width: 100%;

  &__Inputs {
    display: inline-flex;
    align-items: center;
    justify-content: space-between;
  }

  &__Input {
    padding: v.$spacing/2 v.$spacing;
    border: none;
    background-color: transparent;
    color: var(--text-color);
    text-align: center;

    &--dragging {
      opacity: 80%;
    }
  }

  &__Comp {
    .vc-pane-container > :nth-child(3) {
      display: inline-flex;
    }
  }
}
</style>
